/* Inicio creacion de dominios */

SET ECHO ON;
/*
dominio DOM_IDPK = dominio generico para pk's: smallint,not null,> 0,default 1
*/
SET ECHO OFF;
CREATE DOMAIN DOM_IDPK AS SMALLINT
   DEFAULT 1 NOT NULL CHECK ( VALUE > 0 );

SET ECHO ON;
/*
dominio DOM_NOMBRE = dominio generico para nombres o descripciones: varchar(50),not null,con mas de 1 caracter,en mayusculas
*/
SET ECHO OFF;
CREATE DOMAIN DOM_NOMBRE AS VARCHAR(50)
   NOT NULL CHECK ( STRLEN(VALUE) > 1 AND VALUE = UPPER(VALUE) );

SET ECHO ON;
/*
dominio DOM_ROLEQ = { "L" -> local, "V" -> visitante }
*/
SET ECHO OFF;
CREATE DOMAIN DOM_ROLEQ AS char(1)
   DEFAULT 'L' NOT NULL CHECK ( VALUE IN ('L','V') );

SET ECHO ON;
/*
dominio DOM_PUESTO = { "AR" -> arquero, "DF" -> defensor, "MD" -> medio campista, "DE" -> delantero }
*/
SET ECHO OFF;
CREATE DOMAIN DOM_PUESTO AS char(2)
   DEFAULT 'AR' NOT NULL CHECK ( VALUE IN ('AR','DF','MD','DE') );

SET ECHO ON;
/*
dominio DOM_PAROL = { "AR" -> arbitro, "L1" -> linea 1, "L2" -> linea 2 }
*/
SET ECHO OFF;
CREATE DOMAIN DOM_PAROL AS char(2)
   DEFAULT 'AR' NOT NULL CHECK ( VALUE IN ('AR','L1','L2') );

SET ECHO ON;
/*
dominio DOM_PESTADO = { 
		0 -> partido aun no iniciado, solo programado, se sabe el lugar y la fecha
		1 -> partido con equipos asociados
		2 -> partido con autoridades asociadas
		3 -> partido con jugadores asociados
		4 -> partido en "ejecucion"
		5 -> partido finalizado (ya no puede ser modificado)
			}
*/
SET ECHO OFF;
CREATE DOMAIN DOM_PESTADO AS NUMERIC(1,0)
   DEFAULT 0 NOT NULL CHECK ( VALUE BETWEEN 0 AND 5 );

SET ECHO ON;
/* 
dominio DOM_FECHA = DATE,default 'today',not null,donde la fecha debe ser del ao actual
*/
SET ECHO OFF;
CREATE DOMAIN DOM_FECHA AS DATE
   DEFAULT 'today' NOT NULL CHECK ( SUBSTR(CAST(VALUE AS DATE),1,5) = SUBSTR(CAST('TODAY' AS DATE),1,5) );

SET ECHO ON;
/* 
dominio DOM_HORA = TIME,default 'now',not null
*/
SET ECHO OFF;
CREATE DOMAIN DOM_HORA AS TIME
   DEFAULT 'now' NOT NULL;

SET ECHO ON;
/* Dominios creados: */
SHOW DOMAINS;

/* Fin creacion de dominios */
