
/* 
   Inicio Creacion de views2 para tabla de posiciones 
   Verificar: no se permiten utilizacion de select procedures desde views */

SET ECHO OFF;

CREATE VIEW V_EQUIPO_CPG(IDEQ,CPG) AS 
      SELECT E.IDEQ,COUNT(PE.IDEQ) 
      FROM V_PARTIDO P INNER JOIN T_EQ PE       ON P.IDE = PE.IDE AND P.F = PE.F 
                       INNER JOIN T_EQUIPO E    ON E.IDEQ = PE.IDEQ
      WHERE P.CGEQL > P.CGEQV AND PE.ROLEQ = 'L' AND P.ESTADO = 5 
      GROUP BY E.IDEQ
   UNION
      SELECT E.IDEQ,COUNT(PE.IDEQ)
      FROM V_PARTIDO P INNER JOIN T_EQ PE       ON P.IDE = PE.IDE AND P.F = PE.F 
                       INNER JOIN T_EQUIPO E    ON E.IDEQ = PE.IDEQ
      WHERE P.CGEQV > P.CGEQL AND PE.ROLEQ = 'V' AND P.ESTADO = 5 
      GROUP BY E.IDEQ
;

CREATE VIEW V_EQUIPO_CPE(IDEQ,CPE) AS 
   SELECT E.IDEQ,COUNT(PE.IDEQ)
   FROM V_PARTIDO P INNER JOIN T_EQ PE       ON P.IDE = PE.IDE AND P.F = PE.F 
                    INNER JOIN T_EQUIPO E    ON E.IDEQ = PE.IDEQ
   WHERE P.CGEQL = P.CGEQV AND P.ESTADO = 5 
   GROUP BY E.IDEQ
;

CREATE VIEW V_EQUIPO_CPP(IDEQ,CPP) AS 
   SELECT E.IDEQ,COUNT(PE.IDEQ) AS CPP
   FROM V_PARTIDO P INNER JOIN T_EQ PE       ON P.IDE = PE.IDE AND P.F = PE.F 
                    INNER JOIN T_EQUIPO E    ON E.IDEQ = PE.IDEQ
   WHERE ((P.CGEQL > P.CGEQV AND PE.ROLEQ = 'V') OR (P.CGEQV > P.CGEQL AND PE.ROLEQ = 'L')) AND P.ESTADO = 5 
   GROUP BY E.IDEQ
;

CREATE VIEW V_TABLA_PRE1(IDEQ,CPG,CPP,CPE) AS 
      SELECT E.IDEQ,0,0,0
      FROM T_EQUIPO E
   UNION
      SELECT V1.IDEQ,V1.CPG,0,0
      FROM V_EQUIPO_CPG V1
   UNION
      SELECT V1.IDEQ,0,V1.CPP,0
      FROM V_EQUIPO_CPP V1
   UNION
      SELECT V1.IDEQ,0,0,V1.CPE
      FROM V_EQUIPO_CPE V1
;

CREATE VIEW V_TABLA(IDEQ,NOMBRE,CPG,CPP,CPE,PUNTOS) AS 
   SELECT E.IDEQ,E.NOMBRE,CAST(SUM(V1.CPG) AS SMALLINT),
                          CAST(SUM(V1.CPP) AS SMALLINT),
                          CAST(SUM(V1.CPE) AS SMALLINT),
                          CAST( ((SUM(V1.CPG)*3)+SUM(V1.CPE)) AS SMALLINT)
   FROM V_TABLA_PRE1 V1 INNER JOIN T_EQUIPO E      ON V1.IDEQ = E.IDEQ
   GROUP BY E.IDEQ,E.NOMBRE
;

SHOW VIEWS;

SET ECHO ON;

/*  Fin Creacion de views2 */
